
  OMIT('_EndOfIncludeSNMPAPI_',_SNMPAPI_)
_SNMPAPI_ EQUATE(1)

!  COMPILE ('=== DO LINK', _ABCLinkMode_)
    PRAGMA ('link (snmp.lib)')
! === DO LINK

!INT                     EQUATE(LONG)
!UINT                    EQUATE(ULONG)
!BOOL                    EQUATE(BYTE)
!DWORD                   EQUATE(ULONG)
!HANDLE                  EQUATE(SIGNED)
!LPVOID                  EQUATE(LONG)
!PVOID                   EQUATE(LONG)
!LPCSTR                  EQUATE(CSTRING)
!LPSTR                   EQUATE(CSTRING)

ULARGE_INTEGER           GROUP,TYPE
LowPart                    Ulong
HighPart                   Ulong
                         END
! typedef struct {
!     BYTE *stream;
!     UINT  length;
!     BOOL  dynamic;
! } AsnOctetString;

AsnOctetString           GROUP,TYPE
stream                     LONG ! *BYTE
length                     ULONG
dynamic                    BYTE
                           BYTE
                           BYTE
                           BYTE
                         END
! typedef struct {
!     UINT  idLength;
!     UINT *ids;
! } AsnObjectIdentifier;

AsnObjectIdentifier      GROUP,TYPE
idLength                   LONG
ids                        LONG
                         END

AsnInteger32             EQUATE(LONG)
AsnUnsigned32            EQUATE(ULONG)
AsnCounter64             GROUP(ULARGE_INTEGER),TYPE.
AsnCounter32             EQUATE(AsnUnsigned32)
AsnGauge32               EQUATE(AsnUnsigned32)
AsnTimeticks             EQUATE(AsnUnsigned32)
AsnBits                  GROUP(AsnOctetString),TYPE.
AsnSequence              GROUP(AsnOctetString),TYPE.
AsnImplicitSequence      GROUP(AsnOctetString),TYPE.
AsnIPAddress             GROUP(AsnOctetString),TYPE.
AsnNetworkAddress        GROUP(AsnOctetString),TYPE.
AsnDisplayString         GROUP(AsnOctetString),TYPE.
AsnOpaque                GROUP(AsnOctetString),TYPE.
! 
! typedef struct {
!     BYTE asnType;
!     union {
!         AsnInteger32        number;
!         AsnUnsigned32       unsigned32;
!         AsnCounter64        counter64;
!         AsnOctetString      string;
!         AsnBits             bits;
!         AsnObjectIdentifier object;
!         AsnSequence         sequence;
!         AsnIPAddress        address;
!         AsnCounter32        counter;
!         AsnGauge32          gauge;
!         AsnTimeticks        ticks;
!         AsnOpaque           arbitrary;
!     } asnValue;
! } AsnAny;

AsnAny                   GROUP,TYPE
asnType                    BYTE
                           BYTE
                           BYTE
                           BYTE
asnValue                   LONG,DIM(3)
Anynumber                  AsnInteger32,OVER(asnValue)
Anyunsigned32              AsnUnsigned32,OVER(asnValue)
Anycounter64               GROUP(AsnCounter64),OVER(asnValue).
Anystring                  GROUP(AsnOctetString),OVER(asnValue).
Anybits                    GROUP(AsnBits),OVER(asnValue).
Anyobject                  GROUP(AsnObjectIdentifier),OVER(asnValue).
Anysequence                GROUP(AsnSequence),OVER(asnValue).
Anyaddress                 GROUP(AsnIPAddress),OVER(asnValue).
Anycounter                 AsnCounter32,OVER(asnValue)
Anygauge                   AsnGauge32,OVER(asnValue)
Anyticks                   AsnTimeticks,OVER(asnValue)
Anyarbitrary               GROUP(AsnOpaque),OVER(asnValue).
                         END

! typedef AsnObjectIdentifier AsnObjectName;
! typedef AsnAny              AsnObjectSyntax;

AsnObjectName            GROUP(AsnObjectIdentifier),TYPE.
AsnObjectSyntax          GROUP(AsnAny),TYPE.

! typedef struct {
!     AsnObjectName   name;
!     AsnObjectSyntax value;
! } SnmpVarBind;

SnmpVarBind              GROUP,TYPE
name                       GROUP(AsnObjectName).
value                      GROUP(AsnObjectSyntax).
                         END
! typedef struct {
!     SnmpVarBind *list;
!     UINT         len;
! } SnmpVarBindList;

SnmpVarBindList          GROUP,TYPE
list                       LONG !GROUP(SnmpVarBind).
len                        ULONG
                         END
! #include <poppack.h>
ASN_UNIVERSAL                       EQUATE(000h)
ASN_APPLICATION                     EQUATE(040h)
ASN_CONTEXT                         EQUATE(080h)
ASN_PRIVATE                         EQUATE(0c0h)
ASN_PRIMITIVE                       EQUATE(000h)
ASN_CONSTRUCTOR                     EQUATE(020h)
                                    
SNMP_PDU_GET                        EQUATE(ASN_CONTEXT   + ASN_CONSTRUCTOR + 00) 
SNMP_PDU_GETNEXT                    EQUATE(ASN_CONTEXT   + ASN_CONSTRUCTOR + 01)
SNMP_PDU_RESPONSE                   EQUATE(ASN_CONTEXT   + ASN_CONSTRUCTOR + 02)
SNMP_PDU_SET                        EQUATE(ASN_CONTEXT   + ASN_CONSTRUCTOR + 03)
SNMP_PDU_V1TRAP                     EQUATE(ASN_CONTEXT   + ASN_CONSTRUCTOR + 04)
SNMP_PDU_GETBULK                    EQUATE(ASN_CONTEXT   + ASN_CONSTRUCTOR + 05)
SNMP_PDU_INFORM                     EQUATE(ASN_CONTEXT   + ASN_CONSTRUCTOR + 06)
SNMP_PDU_TRAP                       EQUATE(ASN_CONTEXT   + ASN_CONSTRUCTOR + 07)
                                    
ASN_INTEGER                         EQUATE(ASN_UNIVERSAL + ASN_PRIMITIVE   + 02)
ASN_BITS                            EQUATE(ASN_UNIVERSAL + ASN_PRIMITIVE   + 03)
ASN_OCTETSTRING                     EQUATE(ASN_UNIVERSAL + ASN_PRIMITIVE   + 04)
ASN_NULL                            EQUATE(ASN_UNIVERSAL + ASN_PRIMITIVE   + 05)
ASN_OBJECTIDENTIFIER                EQUATE(ASN_UNIVERSAL + ASN_PRIMITIVE   + 06)
ASN_INTEGER32                       EQUATE(ASN_INTEGER)
                                    
ASN_SEQUENCE                        EQUATE(ASN_UNIVERSAL + ASN_CONSTRUCTOR + 10h)
ASN_SEQUENCEOF                      EQUATE(ASN_SEQUENCE)
                                    
ASN_IPADDRESS                       EQUATE(ASN_APPLICATION + ASN_PRIMITIVE   + 00)
ASN_COUNTER32                       EQUATE(ASN_APPLICATION + ASN_PRIMITIVE   + 01)
ASN_GAUGE32                         EQUATE(ASN_APPLICATION + ASN_PRIMITIVE   + 02)
ASN_TIMETICKS                       EQUATE(ASN_APPLICATION + ASN_PRIMITIVE   + 03)
ASN_OPAQUE                          EQUATE(ASN_APPLICATION + ASN_PRIMITIVE   + 04)
ASN_COUNTER64                       EQUATE(ASN_APPLICATION + ASN_PRIMITIVE   + 06)
ASN_UNSIGNED32                      EQUATE(ASN_APPLICATION + ASN_PRIMITIVE   + 07)

SNMP_EXCEPTION_NOSUCHOBJECT          EQUATE(ASN_CONTEXT + ASN_PRIMITIVE + 00)
SNMP_EXCEPTION_NOSUCHINSTANCE        EQUATE(ASN_CONTEXT + ASN_PRIMITIVE + 01)
SNMP_EXCEPTION_ENDOFMIBVIEW          EQUATE(ASN_CONTEXT + ASN_PRIMITIVE + 02)

SNMP_EXTENSION_GET                   EQUATE(SNMP_PDU_GET)
SNMP_EXTENSION_GET_NEXT              EQUATE(SNMP_PDU_GETNEXT)
SNMP_EXTENSION_GET_BULK              EQUATE(SNMP_PDU_GETBULK)
SNMP_EXTENSION_SET_TEST              EQUATE(ASN_PRIVATE + ASN_CONSTRUCTOR + 0)
SNMP_EXTENSION_SET_COMMIT            EQUATE(SNMP_PDU_SET)
SNMP_EXTENSION_SET_UNDO              EQUATE(ASN_PRIVATE + ASN_CONSTRUCTOR + 1)
SNMP_EXTENSION_SET_CLEANUP           EQUATE(ASN_PRIVATE + ASN_CONSTRUCTOR + 2)

SNMP_ERRORSTATUS_NOERROR             EQUATE(0)
SNMP_ERRORSTATUS_TOOBIG              EQUATE(1)
SNMP_ERRORSTATUS_NOSUCHNAME          EQUATE(2)
SNMP_ERRORSTATUS_BADVALUE            EQUATE(3)
SNMP_ERRORSTATUS_READONLY            EQUATE(4)
SNMP_ERRORSTATUS_GENERR              EQUATE(5)
SNMP_ERRORSTATUS_NOACCESS            EQUATE(6)
SNMP_ERRORSTATUS_WRONGTYPE           EQUATE(7)
SNMP_ERRORSTATUS_WRONGLENGTH         EQUATE(8)
SNMP_ERRORSTATUS_WRONGENCODING       EQUATE(9)
SNMP_ERRORSTATUS_WRONGVALUE          EQUATE(10)
SNMP_ERRORSTATUS_NOCREATION          EQUATE(11)
SNMP_ERRORSTATUS_INCONSISTENTVALUE   EQUATE(12)
SNMP_ERRORSTATUS_RESOURCEUNAVAILABLE EQUATE(13)
SNMP_ERRORSTATUS_COMMITFAILED        EQUATE(14)
SNMP_ERRORSTATUS_UNDOFAILED          EQUATE(15)
SNMP_ERRORSTATUS_AUTHORIZATIONERROR  EQUATE(16)
SNMP_ERRORSTATUS_NOTWRITABLE         EQUATE(17)
SNMP_ERRORSTATUS_INCONSISTENTNAME    EQUATE(18)

SNMP_GENERICTRAP_COLDSTART           EQUATE(0)
SNMP_GENERICTRAP_WARMSTART           EQUATE(1)
SNMP_GENERICTRAP_LINKDOWN            EQUATE(2)
SNMP_GENERICTRAP_LINKUP              EQUATE(3)
SNMP_GENERICTRAP_AUTHFAILURE         EQUATE(4)
SNMP_GENERICTRAP_EGPNEIGHLOSS        EQUATE(5)
SNMP_GENERICTRAP_ENTERSPECIFIC       EQUATE(6)

SNMP_ACCESS_NONE                EQUATE(0)
SNMP_ACCESS_NOTIFY              EQUATE(1)
SNMP_ACCESS_READ_ONLY           EQUATE(2)
SNMP_ACCESS_READ_WRITE          EQUATE(3)
SNMP_ACCESS_READ_CREATE         EQUATE(4)

SNMP_LOG_SILENT                 EQUATE(0)
SNMP_LOG_FATAL                  EQUATE(1)
SNMP_LOG_ERROR                  EQUATE(2)
SNMP_LOG_WARNING                EQUATE(3)
SNMP_LOG_TRACE                  EQUATE(4)
SNMP_LOG_VERBOSE                EQUATE(5)

SNMP_OUTPUT_TO_CONSOLE          EQUATE(1)
SNMP_OUTPUT_TO_LOGFILE          EQUATE(2)
SNMP_OUTPUT_TO_EVENTLOG         EQUATE(4)
SNMP_OUTPUT_TO_DEBUGGER         EQUATE(8)

! #define DEFINE_SIZEOF(x)     (sizeof(x)/sizeof((x)[0]))
! #define DEFINE_OID(x)        { DEFINE_SIZEOF(x),(x) }
! #define DEFINE_NULLOID()     { 0, NULL }
! #define DEFINE_NULLOCTENTS() { NULL, 0, FALSE }

DEFAULT_SNMP_PORT_UDP           EQUATE(161)
DEFAULT_SNMP_PORT_IPX           EQUATE(36879)
DEFAULT_SNMPTRAP_PORT_UDP       EQUATE(162)
DEFAULT_SNMPTRAP_PORT_IPX       EQUATE(36880)

SNMP_MAX_OID_LEN                EQUATE(128)

SNMP_MEM_ALLOC_ERROR            EQUATE(0)
SNMP_BERAPI_INVALID_LENGTH      EQUATE(10)
SNMP_BERAPI_INVALID_TAG         EQUATE(11)
SNMP_BERAPI_OVERFLOW            EQUATE(12)
SNMP_BERAPI_SHORT_BUFFER        EQUATE(13)
SNMP_BERAPI_INVALID_OBJELEM     EQUATE(14)
SNMP_PDUAPI_UNRECOGNIZED_PDU    EQUATE(20)
SNMP_PDUAPI_INVALID_ES          EQUATE(21)
SNMP_PDUAPI_INVALID_GT          EQUATE(22)
SNMP_AUTHAPI_INVALID_VERSION    EQUATE(30)
SNMP_AUTHAPI_INVALID_MSG_TYPE   EQUATE(31)
SNMP_AUTHAPI_TRIV_AUTH_FAILED   EQUATE(32)

SNMPAPI_NOERROR                 EQUATE(0) !TRUE
SNMPAPI_ERROR                   EQUATE(1) !FALSE

ASN_RFC1155_IPADDRESS           EQUATE(ASN_IPADDRESS)
ASN_RFC1155_COUNTER             EQUATE(ASN_COUNTER32)
ASN_RFC1155_GAUGE               EQUATE(ASN_GAUGE32)
ASN_RFC1155_TIMETICKS           EQUATE(ASN_TIMETICKS)
ASN_RFC1155_OPAQUE              EQUATE(ASN_OPAQUE)
ASN_RFC1213_DISPSTRING          EQUATE(ASN_OCTETSTRING)
ASN_RFC1157_GETREQUEST          EQUATE(SNMP_PDU_GET)
ASN_RFC1157_GETNEXTREQUEST      EQUATE(SNMP_PDU_GETNEXT)
ASN_RFC1157_GETRESPONSE         EQUATE(SNMP_PDU_RESPONSE)
ASN_RFC1157_SETREQUEST          EQUATE(SNMP_PDU_SET)
ASN_RFC1157_TRAP                EQUATE(SNMP_PDU_V1TRAP)
ASN_CONTEXTSPECIFIC             EQUATE(ASN_CONTEXT)
ASN_PRIMATIVE                   EQUATE(ASN_PRIMITIVE)
RFC1157VarBindList              GROUP(SnmpVarBindList),TYPE.
RFC1157VarBind                  GROUP(SnmpVarBind),TYPE.
AsnInteger                      EQUATE(AsnInteger32)
AsnCounter                      EQUATE(AsnCounter32)
AsnGauge                        EQUATE(AsnGauge32)
                             
! mgmtapi.h                  
SNMP_MGMTAPI_TIMEOUT            EQUATE(40)
SNMP_MGMTAPI_SELECT_FDERRORS    EQUATE(41)
SNMP_MGMTAPI_TRAP_ERRORS        EQUATE(42)
SNMP_MGMTAPI_TRAP_DUPINIT       EQUATE(43)
SNMP_MGMTAPI_NOTRAPS            EQUATE(44)
SNMP_MGMTAPI_AGAIN              EQUATE(45)
SNMP_MGMTAPI_INVALID_CTL        EQUATE(46)
SNMP_MGMTAPI_INVALID_SESSION    EQUATE(47)
SNMP_MGMTAPI_INVALID_BUFFER     EQUATE(48)
MGMCTL_SETAGENTPORT             EQUATE(1)
                             
LPSNMP_MGR_SESSION              EQUATE(LONG)
                             
   MAP                       
     MODULE('SNMP.LIB')
              ! BOOL WINAPI SnmpExtensionInit(DWORD dwUptimeReference,
              !  HANDLE *phSubagentTrapEvent, AsnObjectIdentifier *pFirstSupportedRegion);
            SnmpExtensionInit(DWORD dwUptimeReference,*HANDLE phSubagentTrapEvent, *AsnObjectIdentifier pFirstSupportedRegion),BYTE,PASCAL,RAW
              ! BOOL WINAPI SnmpExtensionInitEx(AsnObjectIdentifier *pNextSupportedRegion);
            SnmpExtensionInitEx(*AsnObjectIdentifier pNextSupportedRegion),BYTE,PASCAL,RAW
              ! BOOL WINAPI SnmpExtensionMonitor(LPVOID pAgentMgmtData);
            SnmpExtensionMonitor(LPVOID pAgentMgmtData),BYTE,PASCAL,RAW
              ! BOOL WINAPI SnmpExtensionQuery(BYTE bPduType, SnmpVarBindList *pVarBindList,
              !  AsnInteger32 *pErrorStatus, AsnInteger32 *pErrorIndex);
            SnmpExtensionQuery(BYTE bPduType, *SnmpVarBindList pVarBindList,*AsnInteger32 pErrorStatus, *AsnInteger32 pErrorIndex),BYTE,PASCAL,RAW
              ! BOOL WINAPI SnmpExtensionQueryEx(UINT nRequestType, UINT nTransactionId,
              !  SnmpVarBindList *pVarBindList, AsnOctetString *pContextInfo,
              !  AsnInteger32 *pErrorStatus, AsnInteger32 *pErrorIndex);
            SnmpExtensionQueryEx(ULONG nRequestType, ULONG nTransactionId,  |
              *SnmpVarBindList pVarBindList, *AsnOctetString pContextInfo, |
              *AsnInteger32 pErrorStatus, *AsnInteger32 pErrorIndex),BYTE,PASCAL,RAW
              ! BOOL WINAPI SnmpExtensionTrap(AsnObjectIdentifier *pEnterpriseOid,
              !  AsnInteger32 *pGenericTrapId, AsnInteger32 *pSpecificTrapId,
              !  AsnTimeticks *pTimeStamp, SnmpVarBindList *pVarBindList);
            SnmpExtensionTrap(*AsnObjectIdentifier pEnterpriseOid, |
              *AsnInteger32 pGenericTrapId, *AsnInteger32 pSpecificTrapId, |
              *AsnTimeticks pTimeStamp, *SnmpVarBindList pVarBindList),BYTE,PASCAL,RAW
              ! VOID WINAPI SnmpExtensionClose(VOID);
            SnmpExtensionClose()
              ! typedef BOOL (WINAPI *PFNSNMPEXTENSIONINIT)(DWORD dwUptimeReference,
              !  HANDLE *phSubagentTrapEvent, AsnObjectIdentifier *pFirstSupportedRegion);
              ! typedef BOOL (WINAPI *PFNSNMPEXTENSIONINITEX)(
              !  AsnObjectIdentifier *pNextSupportedRegion);
              ! 
              ! typedef BOOL (WINAPI *PFNSNMPEXTENSIONMONITOR)(LPVOID pAgentMgmtData);
              ! 
              ! typedef BOOL (WINAPI *PFNSNMPEXTENSIONQUERY)(BYTE bPduType,
              !  SnmpVarBindList *pVarBindList, AsnInteger32 *pErrorStatus,
              !  AsnInteger32 *pErrorIndex);
              ! typedef BOOL (WINAPI *PFNSNMPEXTENSIONQUERYEX)(UINT nRequestType,
              !  UINT nTransactionId, SnmpVarBindList *pVarBindList,
              !  AsnOctetString *pContextInfo, AsnInteger32 *pErrorStatus,
              !  AsnInteger32 *pErrorIndex);
              ! 
              ! typedef BOOL (WINAPI *PFNSNMPEXTENSIONTRAP)(AsnObjectIdentifier *pEnterpriseOid,
              !  AsnInteger32 *pGenericTrapId, AsnInteger32 *pSpecificTrapId,
              !  AsnTimeticks *pTimeStamp, SnmpVarBindList *pVarBindList);
              ! 
              ! typedef VOID (WINAPI *PFNSNMPEXTENSIONCLOSE)(VOID);
              ! 
              ! INT WINAPI SnmpUtilOidCpy(AsnObjectIdentifier *pOidDst,
              !  AsnObjectIdentifier *pOidSrc);
            SnmpUtilOidCpy(*AsnObjectIdentifier pOidDst,*AsnObjectIdentifier pOidSrc),LONG,PASCAL,RAW
              ! INT WINAPI SnmpUtilOidAppend(AsnObjectIdentifier *pOidDst,
              !  AsnObjectIdentifier *pOidSrc);
            SnmpUtilOidAppend(*AsnObjectIdentifier pOidDst,*AsnObjectIdentifier pOidSrc),LONG,PASCAL,RAW
              ! INT WINAPI SnmpUtilOidCmp(AsnObjectIdentifier *pOid1,
              !  AsnObjectIdentifier *pOid2);
            SnmpUtilOidCmp(*AsnObjectIdentifier pOid1,*AsnObjectIdentifier pOid2),LONG,PASCAL,RAW
              ! INT WINAPI SnmpUtilOidNCmp(AsnObjectIdentifier *pOid1,
              !  AsnObjectIdentifier *pOid2, UINT nSubIds);
            SnmpUtilOidNCmp(*AsnObjectIdentifier pOid1,*AsnObjectIdentifier pOid2, ULONG nSubIds),LONG,PASCAL,RAW
              ! VOID WINAPI SnmpUtilOidFree(AsnObjectIdentifier *pOid);
            SnmpUtilOidFree(*AsnObjectIdentifier pOid),PASCAL,RAW
              ! INT WINAPI SnmpUtilOctetsCmp(AsnOctetString *pOctets1,
              !  AsnOctetString *pOctets2);
            SnmpUtilOctetsCmp(*AsnOctetString pOctets1,*AsnOctetString pOctets2),LONG,PASCAL,RAW
              ! INT WINAPI SnmpUtilOctetsNCmp(AsnOctetString *pOctets1,
              !  AsnOctetString *pOctets2, UINT nChars);
            SnmpUtilOctetsNCmp(*AsnOctetString pOctets1,*AsnOctetString pOctets2, ULONG nChars),LONG,PASCAL,RAW
              ! INT WINAPI SnmpUtilOctetsCpy(AsnOctetString *pOctetsDst,
              !  AsnOctetString *pOctetsSrc);
            SnmpUtilOctetsCpy(*AsnOctetString pOctetsDst,*AsnOctetString pOctetsSrc),LONG,PASCAL,RAW
              ! VOID WINAPI SnmpUtilOctetsFree(AsnOctetString *pOctets);
            SnmpUtilOctetsFree(*AsnOctetString pOctets),PASCAL,RAW
              ! INT WINAPI SnmpUtilAsnAnyCpy(AsnAny *pAnyDst, AsnAny *pAnySrc);
            SnmpUtilAsnAnyCpy(*AsnAny pAnyDst, *AsnAny pAnySrc),LONG,PASCAL,RAW
              ! VOID WINAPI SnmpUtilAsnAnyFree(AsnAny *pAny);
            SnmpUtilAsnAnyFree(*AsnAny pAny),PASCAL,RAW
              ! INT WINAPI SnmpUtilVarBindCpy(SnmpVarBind *pVbDst, SnmpVarBind *pVbSrc);
            SnmpUtilVarBindCpy(*SnmpVarBind pVbDst, *SnmpVarBind pVbSrc),LONG,PASCAL,RAW
              ! VOID WINAPI SnmpUtilVarBindFree(*SnmpVarBind pVb);
            SnmpUtilVarBindFree(*SnmpVarBind pVb),PASCAL,RAW
              ! INT WINAPI SnmpUtilVarBindListCpy(SnmpVarBindList *pVblDst,
              !  SnmpVarBindList *pVblSrc);
            SnmpUtilVarBindListCpy(*SnmpVarBindList pVblDst,*SnmpVarBindList pVblSrc),LONG,PASCAL,RAW
              ! VOID WINAPI SnmpUtilVarBindListFree(SnmpVarBindList *pVbl);
            SnmpUtilVarBindListFree(*SnmpVarBindList pVbl),PASCAL,RAW
              ! LPVOID WINAPI SnmpUtilMemAlloc(UINT nBytes) __WINE_ALLOC_SIZE(1);
            SnmpUtilMemAlloc(ULONG nBytes),LONG,PASCAL,RAW
              ! LPVOID WINAPI SnmpUtilMemReAlloc(LPVOID pMem, UINT nBytes) __WINE_ALLOC_SIZE(2);
            SnmpUtilMemReAlloc(LONG pMem, ULONG nBytes),LONG,PASCAL,RAW
              ! VOID WINAPI SnmpUtilMemFree(LPVOID pMem);
            SnmpUtilMemFree(LONG pMem),PASCAL,RAW
              ! LPSTR WINAPI SnmpUtilOidToA(AsnObjectIdentifier *Oid);
            SnmpUtilOidToA(*AsnObjectIdentifier Oid),CSTRING,PASCAL,RAW
              ! LPSTR WINAPI SnmpUtilIdsToA(*UINT Ids, UINT IdLength);
            SnmpUtilIdsToA(*ULONG Ids, ULONG IdLength),CSTRING,PASCAL,RAW
              ! VOID WINAPI SnmpUtilPrintOid(*AsnObjectIdentifier Oid);
            SnmpUtilPrintOid(*AsnObjectIdentifier Oid),PASCAL,RAW
              ! VOID WINAPI SnmpUtilPrintAsnAny(*AsnAny pAny);
            SnmpUtilPrintAsnAny(*AsnAny pAny),PASCAL,RAW
              ! DWORD WINAPI SnmpSvcGetUptime(VOID);
            SnmpSvcGetUptime(),LONG,PASCAL,RAW
              ! VOID WINAPI SnmpSvcSetLogLevel(INT nLogLevel);
            SnmpSvcSetLogLevel(LONG nLogLevel),PASCAL,RAW
              ! VOID WINAPI SnmpSvcSetLogType(INT nLogType);
            SnmpSvcSetLogType(LONG nLogType),PASCAL,RAW
              ! VOID WINAPIV SnmpUtilDbgPrint(INT nLogLevel, LPSTR szFormat, ...);

  ! mgmtapi.h
              !BOOL WINSNMPAPI SnmpMgrClose(LPSNMP_MGR_SESSION);
            SnmpMgrClose(LPSNMP_MGR_SESSION),BYTE,PASCAL,RAW
              !BOOL WINSNMPAPI SnmpMgrCtl(LPSNMP_MGR_SESSION,DWORD,LPVOID,DWORD,LPVOID,DWORD,LPDWORD);
            SnmpMgrCtl(LPSNMP_MGR_SESSION,DWORD,LONG,DWORD,LONG,DWORD,LPDWORD),BYTE,PASCAL,RAW
              !BOOL WINSNMPAPI SnmpMgrGetTrap(AsnObjectIdentifier*,AsnNetworkAddress*,AsnInteger*,AsnInteger*,AsnTimeticks*,SnmpVarBindList*);
            SnmpMgrGetTrap(*AsnObjectIdentifier,*AsnNetworkAddress,*AsnInteger,*AsnInteger,*AsnTimeticks,*SnmpVarBindList),BYTE,PASCAL,RAW
              !BOOL WINSNMPAPI SnmpMgrGetTrapEx(AsnObjectIdentifier*,AsnNetworkAddress*,AsnNetworkAddress*,AsnInteger*,AsnInteger*,AsnOctetString*,AsnTimeticks*,SnmpVarBindList*);
            SnmpMgrGetTrapEx(*AsnObjectIdentifier,*AsnNetworkAddress,*AsnNetworkAddress,*AsnInteger,*AsnInteger,*AsnOctetString,*AsnTimeticks,*SnmpVarBindList),BYTE,PASCAL,RAW
              !BOOL WINSNMPAPI SnmpMgrOidToStr(AsnObjectIdentifier*,LPSTR*);
            SnmpMgrOidToStr(*AsnObjectIdentifier,LONG),BYTE,PASCAL,RAW
              !LPSNMP_MGR_SESSION WINSNMPAPI SnmpMgrOpen(LPSTR,LPSTR,INT,INT);
            SnmpMgrOpen(*CSTRING,*CSTRING,LONG,LONG),LPSNMP_MGR_SESSION,PASCAL,RAW
              !INT WINSNMPAPI SnmpMgrRequest(LPSNMP_MGR_SESSION,BYTE,*SnmpVarBindList,*AsnInteger,*AsnInteger);
            SnmpMgrRequest(LPSNMP_MGR_SESSION,BYTE,*SnmpVarBindList,*AsnInteger,*AsnInteger),LONG,PASCAL,RAW
              !BOOL WINSNMPAPI SnmpMgrStrToOid(LPSTR,*AsnObjectIdentifier);
            SnmpMgrStrToOid(*CSTRING,*AsnObjectIdentifier),BYTE,PASCAL,RAW
              !BOOL WINSNMPAPI SnmpMgrTrapListen(HANDLE*);
            SnmpMgrTrapListen(*HANDLE),BYTE,PASCAL,RAW
     END
   END

 _EndOfIncludeSNMPAPI_
